#ifndef __TSCRAILNET_H
#define __TSCRAILNET_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException
#include <map.h>
#include <string>


/** declarations **/
class TSCRailnet: public Atomic
{
public:
	TSCRailnet( const string &name = "TSCRailnet" );	  // Default constructor

	~TSCRailnet();

	virtual string className() const
		{return "TSCRailnet";}

protected:
	Model &initFunction() ;

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
      int lanes;
      int train;  // 0 = train, 1 = no train
      Port &x_si_tren;
	map<int,Port*> y_t_tren_bt;
	map<int,Port*> y_t_tren_at;
			
};	// class TSCRailnet


#endif   //__TSCRAILNET_H 
