#include "codestruct.h"

void CodeStruct::addTemplate (Template * m)
{
  mTemplate.insert (map < string, Template >::value_type (m->getName (), *m));
}

Template * CodeStruct::getTemplate (string c)
{
  map < string, Template >::iterator s;
  s = mTemplate.find (c);
  if (s == mTemplate.end ())
    {
      string m = "Template specification not found: ";
      m += c;
      throw TException ("getTemplate", m);
    }
  return &(s->second);
}

map < string, Template > *CodeStruct::getMTemplate ()
{
  return &mTemplate;
}

void CodeStruct::addMacro (Macro * m)
{
  mMacro.insert (map < string, Macro >::value_type (m->getName (), *m));
}

Macro * CodeStruct::getMacro (string c)
{
  map < string, Macro >::iterator s;
  s = mMacro.find (c);
  if (s == mMacro.end ())
    {
      string m = "Macro specification not found: ";
      m += c;
      throw TException ("getMacro", m);
    }
  return &(s->second);
}

map < string, Macro > *CodeStruct::getMMacro ()
{
  return &mMacro;
}


void CodeStruct::print ()
{				//print all the info to the stdin    
  cout << "\nCode info\n";
  map < string, Template >::iterator iter;
  map < string, Macro >::iterator iter2;
  if (this->mTemplate.size () != 0)
    {
      cout << "\nList of Templates\n";
      for (iter = mTemplate.begin (); iter != mTemplate.end (); iter++)
	{
	  iter->second.print ();
	  cout << "\n";
	};
    }

  if (this->mMacro.size () != 0)
    {
      cout << "\nList of Macros\n";
      for (iter2 = mMacro.begin (); iter2 != mMacro.end (); iter2++)
	{
	  iter2->second.print ();
	  cout << "\n";
	};
    }

}
