#ifndef __CROSSING_H
#define __CROSSING_H

#include <istream.h>
#include <list.h>
#include <string>
#include "point.h"
#include "segment.h"

//forward declarations
class Segment;
class Point;


class Crossing
{
public:
  void setIdent (string);
  void setPoint (Point);
  void setTLight (string);
  void setHole (string);
  void setSpeed (int);
  void setQcell ();
  void setDelay (int);
  void setPout (int);
  string getIdent ();
  Point getPoint ();
  string getTLight ();
  string getHole ();
  int getSpeed ();
  int getQcell ();
  int getQcellIn ();
  int getQcellOut ();
  int getQSegIn ();
  int getQSegOut ();
  int getDelay ();
  int getPout ();
  void print ();	                  //print the crossing info to the stdin
  bool isInSeg (Segment *);         //returns true if the segment enters to the crossing
  bool isOutSeg (Segment *);        //returns true if the segment exits from the crossing
  void addSeg (Segment *);          //add segment to the crossing
  list < Segment * >*getLSeg ();    //get all the segments in the crossing  
  Segment *getSegment (int);        //da el segmento que se acopla en esa celda
  int getSegmentLane (int);         //da el lane del segmento que se acopla en esa celda

  bool operator == (const Crossing &) const;
  bool operator != (const Crossing &) const;
  bool operator <  (const Crossing &) const;
  bool operator <= (const Crossing &) const;
  bool operator >  (const Crossing &) const;
  bool operator >= (const Crossing &) const;

protected:
  string ident;
  Point point;
  string tLight;	                   // indicates the presence of traffic light
  string hole;                       // indicates the presence of hole
  int speed;
  int qcell;
  int delay;
  int pout;
  list < Segment * >lSeg;           // list of segments in the crossing

private:
};


#endif	/* __CROSSING_H */
