#include "fileadmin.h"

void FileAdmin::setFileName (string s)
{
  this->fileName = s;
}

void FileAdmin::setMacroFileName (string s)
{
  this->macroFileName = s;
}

void FileAdmin::open ()
{
  file = new fstream (fileName.c_str (), ios::out);
  if (file == NULL)
    throw TException ("fileOpen", "Error openning output file ");

  macroFile = new fstream (macroFileName.c_str (), ios::out);
  if (macroFile == NULL)
    throw TException ("fileOpen", "Error openning macro output file ");

  linesTopC = "#include(" + macroFileName + ")\n\n";

}

void FileAdmin::close ()
{
  time_t now;
  time (&now);
  *file << "%-----------------------------------------------------------------------\n";
  *file << "% Code generated by TSC (Traffic Simulator Compiler)\n";
  *file << "% Version: 1.0 \n";
  *file << "% Date   : " << asctime (localtime (&now));
  *file << "%-----------------------------------------------------------------------\n\n";

  *file << linesTopC;
  *file << linesTopP;
  *file << linesTopL;
  *file << lines;
  *file << rules;
  file->close ();

  *macroFile << "%-----------------------------------------------------------------------\n";
  *macroFile << "% Code generated by TSC (Traffic Simulator Compiler)\n";
  *macroFile << "% Version: 1.0 \n";
  *macroFile << "% Date   : " << asctime (localtime (&now));
  *macroFile << "%-----------------------------------------------------------------------\n\n";
  *macroFile << macros;
  macroFile->close ();
}

void FileAdmin::write (string line, string where)
{
  if (where == "body")
    lines += line;
  else if (where == "rule")
    rules += line;
  else if (where == "macro")
    macros += line;
  else if (where == "topC")
    linesTopC += line;
  else if (where == "topP")
    linesTopP += line;
  else if (where == "topL")
    linesTopL += line;
}
