#include "point.h"

void Point::setx (int x)
{
  this->x = x;
}

void Point::sety (int y)
{
  this->y = y;
}

int Point::getx ()
{
  return this->x;
}

int Point::gety ()
{
  return this->y;
}

void Point::print ()
{
  cout << "Point(" << this->x << "," << this->y << ")";
}


bool Point::operator == (const Point & p) const 
{
  return (this->x == p.x && this->y == p.y);
}

bool Point::operator != (const Point & p) const
{
  return (this->x != p.x || this->y != p.y);
}

bool Point::operator < (const Point & p) const
{
  return (this->y < p.y) || (this->y == p.y && this->x < p.x);
}

bool Point::operator <= (const Point & p) const
{
  return (*this < p || *this == p);
}

bool Point::operator > (const Point & p) const
{
  return (this->y > p.y) || (this->y == p.y && this->x > p.x);
}

bool Point::operator >= (const Point & p) const
{
  return (*this > p || *this == p);
}
