#ifndef __TSCCONSUMER_H
#define __TSCCONSUMER_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException
#include <map.h>
#include <string>


/** declarations **/
class TSCConsumer : public Atomic
{
public:
	TSCConsumer( const string &name = "TSCConsumer" );	  // Default constructor

	~TSCConsumer();

	virtual string className() const
		{return "TSCConsumer";}

protected:
	Model &initFunction() ;

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
      int lanes;
      long qty;
	map<int,Port*> x_t_hayauto;
      Port &quantity;
      Port &quantityAcum;
	VTime frecuence;
	VTime timeUnit;
			
};	// class TSCConsumer


#endif   //__TSCCONSUMER_H 
