#ifndef __TSCSINCRORAILNET_H
#define __TSCSINCRORAILNET_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException
#include <map.h>
#include <string>

/** forward declarations **/
class Distribution ;

/** declarations **/
class TSCSincroRailnet : public Atomic
{
public:
	TSCSincroRailnet( const string &name = "TSCSincroRailnet" );	  // Default constructor

	~TSCSincroRailnet();

	virtual string className() const
		{return "TSCSincroRailnet";}

protected:
	Model &initFunction() ;

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
      int railnets;
      int railnet;
	map<int,Port*> y_vt_tren;

	Distribution *dist ;
	Distribution &distribution()
			{return *dist;}
			
};	// class TSCSincroRailnet

#endif   //__TSCSINCRORAILNET_H 
