#include "template.h"

void Template::setName(string c){name = c;}

void Template::setWasUsed(bool b){wasUsed = b;}
void Template::addTopComponents(string c){topComponents.push_back(c);}
void Template::addTopLinks(string c){topLinks.push_back(c);}
void Template::addBeforeNeighbors(string c){beforeNeighbors.push_back(c);}
void Template::addNeighbors(string c){neighbors.push_back(c);}  
void Template::addBeforePorts(string c){beforePorts.push_back(c);}
void Template::addPorts(string c){ports.push_back(c);}  
void Template::addBeforeLinks(string c){beforeLinks.push_back(c);}
void Template::addLinks(string c){links.push_back(c);}
void Template::addBeforeZones(string c){beforeZones.push_back(c);}
void Template::addZones(string c){zones.push_back(c);}
void Template::addBeforeRules(string c){beforeRules.push_back(c);}
void Template::addRules(RuleBlock *rb){rules.push_back(*rb);}
void Template::addAfterRules(string c){afterRules.push_back(c);}

string Template::getName(){return name;}
bool Template::getWasUsed(){return wasUsed;}
list<string>* Template::getTopComponents(){return &topComponents;}
list<string>* Template::getTopLinks(){return &topLinks;}
list<string>* Template::getBeforeNeighbors(){return &beforeNeighbors;}
list<string>* Template::getNeighbors(){return &neighbors;}
list<string>* Template::getBeforePorts(){return &beforePorts;}
list<string>* Template::getPorts(){return &ports;}
list<string>* Template::getBeforeLinks(){return &beforeLinks;}
list<string>* Template::getLinks(){return &links;}
list<string>* Template::getBeforeZones(){return &beforeZones;}
list<string>* Template::getZones(){return &zones;}
list<string>* Template::getBeforeRules(){return &beforeRules;}
list<RuleBlock>* Template::getRules(){return &rules;}
list<string>* Template::getAfterRules(){return &afterRules;}


void Template::print(){
list<string>::iterator   iter;
cout << this->name << ":\n";
if (this->topComponents.size() != 0)
   {cout << "List of Top Components\n";
   for (iter = this->topComponents.begin(); iter != this->topComponents.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->topLinks.size() != 0)
   {cout << "List of Top Links\n";
   for (iter = this->topLinks.begin(); iter != this->topLinks.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->beforeNeighbors.size() != 0)
   {cout << "List of Before Neighbors\n";
   for (iter = this->beforeNeighbors.begin(); iter != this->beforeNeighbors.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->neighbors.size() != 0)
   {cout << "List of Neighbors\n";
   for (iter = this->neighbors.begin(); iter != this->neighbors.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->beforePorts.size() != 0)
   {cout << "List of Before Ports\n";
   for (iter = this->beforePorts.begin(); iter != this->beforePorts.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->ports.size() != 0)
   {cout << "List of Ports\n";
   for (iter = this->ports.begin(); iter != this->ports.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->beforeLinks.size() != 0)
   {cout << "List of Before Links\n";
   for (iter = this->beforeLinks.begin(); iter != this->beforeLinks.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->links.size() != 0)
   {cout << "List of Links\n";
   for (iter = this->links.begin(); iter != this->links.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->beforeZones.size() != 0)
   {cout << "List of Before Zones\n";
   for (iter = this->beforeZones.begin(); iter != this->beforeZones.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->zones.size() != 0)
   {cout << "List of Zones\n";
   for (iter = this->zones.begin(); iter != this->zones.end(); iter++)
       {cout << "   " << (*iter);};
    }
if (this->beforeRules.size() != 0)
   {cout << "List of Before Rules\n";
   for (iter = this->beforeRules.begin(); iter != this->beforeRules.end(); iter++)
       {cout << "   " << (*iter);};
    }

list<RuleBlock>::iterator   iter2;
if (this->rules.size() != 0)
   {cout << "List of Dependent Rules\n";
   for (iter2 = this->rules.begin(); iter2 != this->rules.end(); iter2++)
       {iter2->print();};
    }

if (this->afterRules.size() != 0)
   {cout << "List of After Rules\n";
   for (iter = this->afterRules.begin(); iter != this->afterRules.end(); iter++)
       {cout << "   " << (*iter);};
    }
}




